import 'dart:collection';

import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/for_list.dart';
import 'package:objd/basic/score.dart';
import 'package:objd/basic/scoreboard.dart';
import 'package:objd/basic/widget.dart';

class Stats {
	static final HashMap<String, Scoreboard> _boards = HashMap();
	static final HashMap<String, HashMap<Entity, Score>> _scores = HashMap();

	static Widget load() {
		return For.of([
			..._boards.values
		]);
	}

	static Widget tick() {
		return null;
	}

	static void _addStat(String name, Function action, Entity entity) {
		if (!_boards.containsKey(name)) {
			_boards[name] = Scoreboard(name, addIntoLoad: false);
			_scores[name] = HashMap();
		}

		if (!_scores[name].containsKey(entity)) {
			_scores[name][entity] = Score(entity, name, addNew: false);
		}
	}

	static Condition then(String name, Score Function(Score) action, [Entity entity]) {
		final entityOrPlayer = entity ?? Entity.Player();
		_addStat(name, action, entityOrPlayer);

		return Condition.score(action(_scores[name][entity]));
	}
}
